import logging

from upload.lib.base import *

log = logging.getLogger(__name__)

import os
import shutil
import cgi
from mimetypes import guess_type

class ProgressFile(file):
    def write(self, *k, **p):
        if hasattr(self, 'callback'):
            self.callback(self, *k, **p)
        return file.write(self, *k,**p)

    def set_callback(self, callback):
        self.callback = callback

def stream(file_object):

    class CustomFieldStorage(cgi.FieldStorage):
        def make_file(self, binary=None):
            self.open_file = file_object
            return self.open_file

    return CustomFieldStorage

class UpController(BaseController):
    def upload(self):

        def callback(file, *k, **p):
            log.debug("Logged %s", [file.tell()])
    
        fp = ProgressFile('somefile', 'wb')
        fp.set_callback(callback)
        custom_field_storage = stream(fp)(
            environ=request.environ, 
            strict_parsing=True, 
            fp=request.environ['wsgi.input']
        )
        fp.close()
        # You could rename the file at this point if you liked
        return 'Uploaded '+custom_field_storage['Filedata'].filename

    def download_file(self):
        filename = 'somefile'
        fp = open(filename, 'rb')
        data = fp.read()
        fp.close()
        response.headers['Content-type'] = guess_type(filename)
        response.headers['Content-disposition'] = 'attachment; filename="%s"'%filename
        return data
        
    def index(self):
        return """
    <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
    	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
    
    <html xmlns="http://www.w3.org/1999/xhtml" >
    <head>
        <title>Upload files using flash and javascript - SWFUpload</title>
    	<script type="text/javascript" src="jscripts/SWFUpload/SWFUpload.js"></script>
    	<script type="text/javascript" src="jscripts/example_callbacks.js"></script>
    	<script type="text/javascript">
    		var swfu;
    		var swfu2;
    		window.onload = function() {
    			// Max settings
    			swfu = new SWFUpload({
    				upload_script : "/up/upload",
    				target : "SWFUploadTarget",
    				flash_path : "jscripts/SWFUpload/SWFUpload.swf",
    				allowed_filesize : 3072000,	// 3000 MB
    				allowed_filetypes : "*.*",
    				allowed_filetypes_description : "All files...",
    				browse_link_innerhtml : "Browse",
    				upload_link_innerhtml : "Upload queue",
    				browse_link_class : "swfuploadbtn browsebtn",
    				upload_link_class : "swfuploadbtn uploadbtn",
    				flash_loaded_callback : 'swfu.flashLoaded',
    				upload_file_queued_callback : "fileQueued",
    				upload_file_start_callback : 'uploadFileStart',
    				upload_progress_callback : 'uploadProgress',
    				upload_file_complete_callback : 'uploadFileComplete',
    				upload_file_cancel_callback : 'uploadFileCancelled',
    				upload_queue_complete_callback : 'uploadQueueComplete',
    				upload_error_callback : 'uploadError',
    				upload_cancel_callback : 'uploadCancel',
    				auto_upload : false			
    			});
    		}
    	</script>
    	<style type="text/css">
    		.swfuploadbtn {
    			display: block;
    			width: 100px;
    			padding: 0 0 0 20px;
    		}
    		.browsebtn { background: url(/images/add.png) no-repeat 0 4px; }
    		.uploadbtn { 
    			display: none;
    			background: url(/images/accept.png) no-repeat 0 4px; 
    		}
    		.cancelbtn { 
    			display: block;
    			width: 16px;
    			height: 16px;
    			float: right;
    			background: url(/images/cancel.png) no-repeat; 
    		}
    		#cancelqueuebtn {
    			display: block;
    			display: none;
    			background: url(/images/cancel.png) no-repeat 0 4px;
    			margin: 10px 0;
    		}
    		#SWFUploadFileListingFiles ul {
    			margin: 0;
    			padding: 0;
    			list-style: none;
    		}
    		.SWFUploadFileItem {
    			display: block;
    			width: 230px;
    			height: 70px;
    			float: left;
    			background: #eaefea;
    			margin: 0 10px 10px 0;
    			padding: 5px;
    
    		}
    		.fileUploading { background: #fee727; }
    		.uploadCompleted { background: #d2fa7c; }
    		.uploadCancelled { background: #f77c7c; }
    		.uploadCompleted .cancelbtn, .uploadCancelled .cancelbtn {
    			display: none;
    		}
    		span.progressBar {
    			width: 200px;
    			display: block;
    			font-size: 10px;
    			height: 4px;
    			margin-top: 2px;
    			margin-bottom: 10px;
    			background-color: #CCC;
    		}
    	</style>
    </head>
    <body>
    	<h1><span>SWFUpload Testpage</span></h1>
    		<h2>Upload Example</h2>
    		<p>Replace contents of a div with links for uploading and browsing,
                degrades gracefully if flash/javascript isn't accessible</p>
    		<div id="SWFUploadTarget">
    			<form action="upload.php" method="post" enctype="multipart/form-data">
    
    				<input type="file" name="Filedata" id="Filedata" />
    				<input type="submit" value="upload test" />
    			</form>
    		</div>
    		<h4 id="queueinfo">Queue is empty</h4>
    		<div id="SWFUploadFileListingFiles"></div>
    		<br class="clr" />
    		<a class="swfuploadbtn" id="cancelqueuebtn" 
                href="javascript:cancelQueue();">Cancel queue</a>
    		</body>
    </html>
    """
